
/*------------------------------------------------------------------------
    File        : HttpClientDemo1.p
    Purpose     : 

    Syntax      :

    Description : 

    Author(s)   : 
    Created     : Fri Jun 05 10:51:48 EDT 2015
    Notes       :
  ----------------------------------------------------------------------*/
USING System.Net.Http.*.
USING System.Xml.*.
USING System.IO.*.

DEFINE VARIABLE Client            AS HttpClient.
DEFINE VARIABLE URL               AS CHARACTER.
DEFINE VARIABLE Response          AS "System.Threading.Tasks.Task<HttpResponseMessage>".
DEFINE VARIABLE ResponseChar      AS "System.Threading.Tasks.Task<Character>".
DEFINE VARIABLE ResponseStream    AS "System.Threading.Tasks.Task<Stream>".
DEFINE VARIABLE ResponseByteArray AS "System.Threading.Tasks.Task<System.Byte[]>".
DEFINE VARIABLE Address           AS CHARACTER.
DEFINE VARIABLE xDoc              AS XmlDocument.

Address = "14 Oak Bedford ma".
URL = "http://maps.googleapis.com/maps/api/geocode/xml?sensor=false&address=".
URL = URL + address.

Client = NEW HttpClient().
xDoc = NEW XmlDocument().
ResponseStream = Client:GetStreamAsync(URL).
xDoc:Load(ResponseStream:Result).


/* Use XPath expressions to access the node values */
MESSAGE
  
  "Formatted Address: "
  xdoc:SelectSingleNode("//formatted_address"):InnerText SKIP
  "Latitude: "
  xdoc:SelectSingleNode("//location/lat"):InnerText SKIP
  "Longitude: "
  xdoc:SelectSingleNode("//location/lng"):InnerText SKIP
  VIEW-AS ALERT-BOX.
  
/*ResponseChar = Client:GetStringAsync(URL).*/

/*ResponseByteArray = Client:GetByteArrayAsync(URL).*/

/*Response = Client:GetAsync(URL).*/
/*Response:Result:Content:CopyToAsync(myStream).*/


/*MESSAGE ResponseChar:Result*/
/*VIEW-AS ALERT-BOX.         */
 
/*myStream:Position = 0.*/

/*MESSAGE Response:Result:Content:ToString() SKIP*/
/*Response:IsCompleted                           */
/*VIEW-AS ALERT-BOX.                             */
/*myStream = cast(Response:Result:Content:ReadAsStreamAsync(), System.IO.Stream).*/
/*xDoc:Load(cast(Response:Result:Content,System.IO.Stream)).                     */


