
/*------------------------------------------------------------------------
    File        : PrgsHTTPClient.p
    Purpose     : 

    Syntax      :

    Description : 

    Author(s)   : 
    Created     : Fri May 29 12:57:49 EDT 2015
    Notes       :
  ----------------------------------------------------------------------*/
USING OpenEdge.Net.Http.*.
USING OpenEdge.Net.*.
USING System.Web.*.

DEFINE VARIABLE URL       AS CHARACTER.
DEFINE VARIABLE oResponse AS IHttpResponse.
DEFINE VARIABLE oRequest  AS IHttpRequest.
def var oUri as URI.
DEFINE VARIABLE vAddress  AS CHARACTER.
DEFINE VARIABLE hXMLDoc   AS HANDLE.
DEFINE VARIABLE hDS       AS HANDLE.
DEFINE VARIABLE hBuff     AS HANDLE.
DEFINE VARIABLE i         AS INTEGER.
DEFINE VARIABLE y         AS INTEGER.
DEFINE VARIABLE fieldList AS CHARACTER.

vAddress = "14 Oak Bedford ma".
/*URL = "maps.googleapis.com/maps/api/geocode/xml?sensor=false&address=14+Oak+Bedford+Ma".*/
/*URL = "maps.googleapis.com/maps/api/geocode/xml?sensor=false&address=14%20Oak%20Bedford%20Ma".*/
/*vaddress = HttpUtility:UrlEncode(vAddress).*/
/*vAddress = replace(vAddress," ","+").*/

vaddress = URI:Encode(vAddress, UriEncodingTypeEnum:Query).

URL = "maps.googleapis.com".
/*URL = URL + vaddress.*/
oUri = NEW Uri(URL).
oUri:Path = "/maps/api/geocode/xml".
oUri:AddQuery("sensor", "false").
oUri:AddQuery("address", vAddress).
MESSAGE 
oURI:ToString() skip
oURI:BaseURI skip
oURI:querystring
VIEW-AS ALERT-BOX.
oRequest = RequestBuilder:Get(oUri):Request.
oResponse = ClientBuilder:Build():Client:Execute(oRequest).

MESSAGE oResponse:ContentType
  VIEW-AS ALERT-BOX.
hXmlDoc = CAST(oResponse:Entity, OpenEdge.Core.WidgetHandle):Value.

CREATE DATASET hDS.
hDS:READ-XML("HANDLE", hXmlDoc, "Empty", ?, ? ).

DO y = 1 TO hDS:NUM-BUFFERS.
  hBuff = hDS:GET-BUFFER-HANDLE(y).
  DO i = 1 TO hBuff:NUM-FIELDS:
    fieldList = fieldList + hBuff:NAME + "." + hBuff:BUFFER-FIELD(i):Name + " - " +
      hBuff:BUFFER-FIELD(i):data-type + "~n".
  END.
END.

MESSAGE 
  "Number of Buffers: " hDS:NUM-BUFFERS SKIP 
  "Fields: " SKIP
  fieldList
  VIEW-AS ALERT-BOX.

hBuff = hDS:GET-BUFFER-HANDLE("result").
hBuff:FIND-FIRST().
MESSAGE hBuff:BUFFER-FIELD("formatted_address"):buffer-Value
  VIEW-AS ALERT-BOX.

hBuff = hDS:GET-BUFFER-HANDLE("location").
hBuff:FIND-FIRST().
MESSAGE hBuff:BUFFER-FIELD("lat"):buffer-Value SKIP
  hBuff:BUFFER-FIELD("lng"):buffer-Value
  VIEW-AS ALERT-BOX.
DELETE OBJECT hDS.  